#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#define DB double
#include <complex.h>
#define z_type complex<double>
#define Re(x) (x).real()
#define Im(x) (x).imag()
#define I z_type(0.,1.)
z_type Zo=z_type(.31813150520476413, 1.3372357014306895);
z_type Zc=z_type(.31813150520476413,-1.3372357014306895);

#define DO(x,y) for(x=0;x<y;x++)
#include "f3c.cin"
#include"ado.cin"
#define DO(x,y) for(x=0;x<y;x++)
#define M(x,y) fprintf(o,"%5.3f %5.3f M\n",1.*(x),1.*(y));
#define L(x,y) fprintf(o,"%5.3f %5.3f L\n",1.*(x),1.*(y));
#define o(x,y) fprintf(o,"%5.3f %5.3f o\n",1.*(x),1.*(y));

main(){ int j,k,m,n; DB x,y, u, t; z_type z,c,d, cu,cd; 
#include "GLxw2048.inc"
int K=NPO; DB A=24.; printf("K=%3d A=%3.1f\n",K,A);
int J=K-1;  z_type E[K],F[K],G[K],H[K];

printf( "plot in fig0first.eps\n");
FILE *o;o=fopen("fig0first.eps","w");ado(o,0,0,484,32);
fprintf(o,"242 16 translate\n 10 10 scale\n");
for(j=-10;j<11;j+=1){M(j,-1.5)L(j,1.5);}
M(-10 , 1)L(10 , 1); 
M(-10 ,-1)L(10 ,-1);  fprintf(o,".006 W S\n");
M(-10.1,0)L(10.1,0);  fprintf(o,".02 W S\n");
fprintf(o,".01 W S\n 1 setlinejoin\n");

DO(n,K){y=GLx[n]*A; 
	if(y<-3)  	E[n]=F[n]=G[n]=Zc;
	else {if(y>3)	E[n]=F[n]=G[n]=Zo;
		else {  F[n]=c=f3(z_type(0.,y));
			E[n]=log(c);
			G[n]=exp(c);	
		     }
	     }
	}
DO(k,K){y=GLx[k]*A; u=Re(F[k]);if(k==0)M(y,u)else L(y,u)}
DO(k,K){y=GLx[k]*A; u=Im(F[k]);if(k==0)M(y,u)else L(y,u)} fprintf(o,".08 W 1 .4 1 RGB S\n");

//DO(n,K/2)
for(n=0;n<K;n+=2)
	{ j=J-n; y=GLx[n]*A; z=z_type(0.,y); c=0.;  //printf(" %3d",n);
	 DO(k,K){t=A*GLx[k]; c+= GLw[k]*( G[k]/(z_type( 1.,t)-z) - E[k]/(z_type(-1.,t)-z) );}	
	 cu=.5-I/(2.*M_PI)*log( (z_type(1.,-A)+z)/(z_type(1., A)-z) );
	 cd=.5-I/(2.*M_PI)*log( (z_type(1.,-A)-z)/(z_type(1., A)+z) );
	 c=c*(A/(2.*M_PI)) +Zo*cu+Zc*cd;
	 if(abs(n-K/2)<4)printf("%3d %6.3f  %9.6f %9.6f  %9.6f %9.6f\n",n,y,Re(F[n]),Im(F[n]),Re(c),Im(c));
	 E[n]=log(c);	E[j]=conj(E[n]);	 
	 F[n]=c;	F[j]=conj(c);
	 G[n]=exp(c);	G[j]=conj(G[n]);}

DO(k,K){y=GLx[k]*A; u=Re(F[k]);if(k==0)M(y,u)else L(y,u)}
DO(k,K){y=GLx[k]*A; u=Im(F[k]);if(k==0)M(y,u)else L(y,u)} fprintf(o,".06 W 1 0 0 RGB S\n");

DO(n,K) H[n]=F[n];
//DO(n,K/2)
for(n=1;n<K;n+=2)
	{ j=J-n; y=GLx[n]*A; z=z_type(0.,y); c=0.;  //printf(" %3d",n);
	 DO(k,K){t=A*GLx[k]; c+= GLw[k]*( G[k]/(z_type( 1.,t)-z) - E[k]/(z_type(-1.,t)-z) );}	
	 cu=.5-I/(2.*M_PI)*log( (z_type(1.,-A)+z)/(z_type(1., A)-z) );
	 cd=.5-I/(2.*M_PI)*log( (z_type(1.,-A)-z)/(z_type(1., A)+z) );
	 c=c*(A/(2.*M_PI)) +Zo*cu+Zc*cd;
	 if(abs(n-K/2)<4)printf("%3d %6.3f  %9.6f %9.6f  %9.6f %9.6f\n",n,y,Re(F[n]),Im(F[n]),Re(c),Im(c));
	 E[n]=log(c);	E[j]=conj(E[n]);	 
	 F[n]=c;	F[j]=conj(c);
	 G[n]=exp(c);	G[j]=conj(G[n]);}

DO(k,K){y=GLx[k]*A; u=Re(F[k]);if(k==0)M(y,u)else L(y,u)}
DO(k,K){y=GLx[k]*A; u=Im(F[k]);if(k==0)M(y,u)else L(y,u)} fprintf(o,".04 W 0 1 0 RGB S\n");

fprintf(o,"showpage\n\%\%\%Trailer"); fclose(o); 
//system( "ggv fig0first.eps");
system(  "open fig0first.eps");
system("ps2pdf fig0first.eps");

printf("plot in fig0test.eps\n");
       o=fopen("fig0test.eps","w");ado(o,0,0,484,52);
fprintf(o,"242 16 translate\n 10 10 scale\n");
for(j=-10;j<11;j+=1){M(j,-1.5)L(j,1.5);}
M(-10 , 1)L(10 , 1); 
M(-10 ,-1)L(10 ,-1);  fprintf(o,".006 W S\n");
M(-10.1,0)L(10.1,0);  fprintf(o,".01 W S\n 1 setlinejoin\n");

DO(k,K){y=GLx[k]*A; u=100*Re(H[k]-F[k]);if(k==0)M(y,u)else L(y,u)}
DO(k,K){y=GLx[k]*A; u=100*Im(H[k]-F[k]);if(k==0)M(y,u)else L(y,u)} fprintf(o,".04 W 1 0 0 RGB S\n");

DO(n,K) H[n]=F[n];
DO(n,K){ j=J-n; y=GLx[n]*A; z=z_type(0.,y); c=0.;  //printf(" %3d",n);
	 DO(k,K){t=A*GLx[k]; c+= GLw[k]*( G[k]/(z_type( 1.,t)-z) - E[k]/(z_type(-1.,t)-z) );}	
	 cu=.5-I/(2.*M_PI)*log( (z_type(1.,-A)+z)/(z_type(1., A)-z) );
	 cd=.5-I/(2.*M_PI)*log( (z_type(1.,-A)-z)/(z_type(1., A)+z) );
	 c=c*(A/(2.*M_PI)) +Zo*cu+Zc*cd;
	 if(abs(n-K/2)<4)printf("%3d %6.3f  %9.6f %9.6f  %9.6f %9.6f\n",n,y,Re(F[n]),Im(F[n]),Re(c),Im(c));
	 E[n]=log(c);	E[j]=conj(E[n]);	 
	 F[n]=c;	F[j]=conj(c);
	 G[n]=exp(c);	G[j]=conj(G[n]);}

DO(k,K){y=GLx[k]*A; u=100*Re(H[k]-F[k]);if(k==0)M(y,u)else L(y,u)}
DO(k,K){y=GLx[k]*A; u=100*Im(H[k]-F[k]);if(k==0)M(y,u)else L(y,u)} fprintf(o,".03 W 0 1 0 RGB S\n");

DO(n,K) H[n]=F[n];
DO(n,K){ j=J-n; y=GLx[n]*A; z=z_type(0.,y); c=0.;  //printf(" %3d",n);
	 DO(k,K){t=A*GLx[k]; c+= GLw[k]*( G[k]/(z_type( 1.,t)-z) - E[k]/(z_type(-1.,t)-z) );}	
	 cu=.5-I/(2.*M_PI)*log( (z_type(1.,-A)+z)/(z_type(1., A)-z) );
	 cd=.5-I/(2.*M_PI)*log( (z_type(1.,-A)-z)/(z_type(1., A)+z) );
	 c=c*(A/(2.*M_PI)) +Zo*cu+Zc*cd;
	 if(abs(n-K/2)<4)printf("%3d %6.3f  %9.6f %9.6f  %9.6f %9.6f\n",n,y,Re(F[n]),Im(F[n]),Re(c),Im(c));
	 E[n]=log(c);	E[j]=conj(E[n]);	 
	 F[n]=c;	F[j]=conj(c);
	 G[n]=exp(c);	G[j]=conj(G[n]);}

DO(k,K){y=GLx[k]*A; u=100*Re(H[k]-F[k]);if(k==0)M(y,u)else L(y,u)}
DO(k,K){y=GLx[k]*A; u=100*Im(H[k]-F[k]);if(k==0)M(y,u)else L(y,u)} fprintf(o,".02 W 0 0 1 RGB S\n");

DO(n,K) H[n]=F[n];
DO(m,64)
//DO(n,K)
for(n=0;n<K;n+=2)
	{ j=J-n; y=GLx[n]*A; z=z_type(0.,y); c=0.;  //printf(" %3d",n);
	 DO(k,K){t=A*GLx[k]; c+= GLw[k]*( G[k]/(z_type( 1.,t)-z) - E[k]/(z_type(-1.,t)-z) );}	
	 cu=.5-I/(2.*M_PI)*log( (z_type(1.,-A)+z)/(z_type(1., A)-z) );
	 cd=.5-I/(2.*M_PI)*log( (z_type(1.,-A)-z)/(z_type(1., A)+z) );
	 c=c*(A/(2.*M_PI)) +Zo*cu+Zc*cd;
	 if(n==K/2)printf("%3d %17.13f %17.14f  %17.14f %17.14f\n",m,Re(F[n]),Im(F[n]),Re(c),Im(c));
	 E[n]=log(c);	E[j]=conj(E[n]);	 
	 F[n]=c;	F[j]=conj(c);
	 G[n]=exp(c);	G[j]=conj(G[n]);}

DO(k,K){y=GLx[k]*A; u=100*Re(H[k]-F[k]);if(k==0)M(y,u)else L(y,u)}
DO(k,K){y=GLx[k]*A; u=100*Im(H[k]-F[k]);if(k==0)M(y,u)else L(y,u)} fprintf(o,".02 W .4 0 .4 RGB S\n");

fprintf(o,"showpage\n\%\%\%Trailer"); fclose(o); 
//system( "ggv fig0test.eps");
system(  "open fig0test.eps");
system("ps2pdf fig0test.eps");

o=fopen("fig0.dat","w");
DO(k,K) fprintf(o,"%4d %18.14f %18.14f\n",k,Re(F[k]),Im(F[k]));
fclose(o);

getchar(); system("killall Preview");
}
