#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#define DB double
#include <complex.h>
#define z_type complex<double>
#define Re(x) x.real()
#define Im(x) x.imag()
#define I z_type(0.,1.)
#include "f3c.cin"
#include "advacon.cin"
main(){ int j,k,m,n; DB x,y, u, t; z_type z,c,d, cu,cd;
z_type Zo=z_type(.31813150520476413, 1.3372357014306895);
z_type Zc=z_type(.31813150520476413,-1.3372357014306895);
int K=200,K1=K+1;
DB A=10.;  DB dy=2*A/K;  printf("dy=%6.3f",dy);
#define Y(k) (dy*(k-K/2))
printf("y_0=%6.3f y_K=%6.3f ",Y(0), Y(K));

printf( "plot in fig03.eps\n");
FILE *o;o=fopen("fig03.eps","w");ado(o,0,0,102,32);
fprintf(o,"51 16 translate\n 10 10 scale\n");
for(j=-50;j<60;j+=10){ if(j!=0){M(.1*j,-1.5)L(.1*j,1.5);}}
for(k=-10;k<20;k+=10){ if(k!=0){M(-5,.1*k)L(5,.1*k);}}   fprintf(o,".01 W S\n");
M(0,-1.58)L(0,1.58)             M(-5.08,0)L(5.08,0);   fprintf(o,".015 W S\n");

//M(-3,Re(Zo)) L(3,Re(Zo)) M(-3,Im(Zo)) L(3,Im(Zo)) M(-3,-Im(Zo)) L(3,-Im(Zo))
//fprintf(o,".01 W 0 .4 0 RGB S\n");

z_type Fo[K1]; 
DO(k,K1){y=Y(k);if(y<-3)	Fo[k]=Zc;
		 else{ if(y> 3) Fo[k]=Zo;
		       else Fo[k]=f3(z_type( 0.,Y(k)));
		     }
	}
z_type Fm[K1]; DO(k,K1){Fm[k]=log(Fo[k]);}
z_type Fp[K1]; DO(k,K1){Fp[k]=exp(Fo[k]);}

for(k=K/4; k<= 3*K/4; k++ ){y=Y(k);u=Re(Fo[k]);if(k==K/4)M(y,u)else L(y,u)}fprintf(o,".1 W .7 1 .7 RGB S\n");
for(k=K/4; k<= 3*K/4; k++ ){y=Y(k);u=Im(Fo[k]);if(k==K/4)M(y,u)else L(y,u)}fprintf(o,".1 W .7 1 .7 RGB S\n");
//DO(k,K1){y=Y(k);u=Im(Fo[k]);if(k==0)M(y,u)else L(y,u)}fprintf(o,".2 W 0 1 0 RGB S\n");


/*
fprintf(o,".06 W\n");
//DO(k,K1){y=Y(k);u=Re(Fm[k]);if(k/2*2==k)M(y,u)else L(y,u)}fprintf(o,"1 .6 0 RGB S\n");
DO(k,K1){y=Y(k);u=Re(Fo[k]);if(k/2*2==k)M(y,u)else L(y,u)}fprintf(o,"0 1 0 RGB S\n");
//DO(k,K1){y=Y(k);u=Re(Fp[k]);if(k/2*2==k)M(y,u)else L(y,u)}fprintf(o,"0 .6 1 RGB S\n");
//DO(k,K1){y=Y(k);u=Im(Fm[k]);if(k/2*2==k)M(y,u)else L(y,u)}fprintf(o,"1 .6 0 RGB S\n");
DO(k,K1){y=Y(k);u=Im(Fo[k]);if(k/2*2==k)M(y,u)else L(y,u)}fprintf(o,"0 1 0 RGB S\n");
//DO(k,K1){y=Y(k);u=Im(Fp[k]);if(k/2*2==k)M(y,u)else L(y,u)}fprintf(o,"0 .6 1 RGB S\n");
fprintf(o,".02 W\n");
//DO(k,K1){y=Y(k);u=Re(Fm[k]);if(k==0)M(y,u)else L(y,u)} fprintf(o,".5 0 0 RGB S\n");
//DO(k,K1){y=Y(k);u=Re(Fp[k]);if(k==0)M(y,u)else L(y,u)} fprintf(o,"0 0 .5 RGB S\n");
//DO(k,K1){y=Y(k);u=Im(Fm[k]);if(k==0)M(y,u)else L(y,u)} fprintf(o,".5 0 0 RGB S\n");
DO(k,K1){y=Y(k);u=Im(Fp[k]);if(k==0)M(y,u)else L(y,u)} fprintf(o,"0 0 .5 RGB S\n");
*/

z_type gf[K1];
DO(k,K) gf[k]=Fo[k];
//DO(k,K) gf[K-k]=conj(Fo[k]);

//DO(k,K1){y=Y(k);u=Re(gf[k]);if(k==0)M(y,u)else L(y,u)}fprintf(o,".9 1 .9 RGB S\n");
//DO(k,K1){y=Y(k);u=Im(gf[k]);if(k==0)M(y,u)else L(y,u)}fprintf(o,".9 1 .9 RGB S\n");

 x=0;
DO(j,44){
for(k=0;k<K/2;k++)
	{y=Y(k); c=0.; z=z_type(x,y);
	DO(m,K){	t=Y(m); d= Fp[m]/z_type(1.,t-y) 
				+  Fm[m]/z_type(1.,y-t) ;
			if(m==0 ||m==K) d/=2; c+=d;	}
	cu=.5-I/(2.*M_PI)*log( (z_type(1.,-A)+z)/(z_type(1., A)-z) );
        cd=.5-I/(2.*M_PI)*log( (z_type(1.,-A)-z)/(z_type(1., A)+z) );
	gf[k]=c*(dy/(2.*M_PI)) + Zo*cu+Zc*cd;
	if(fabs(y)>.20001){
		Fp[k]=exp(gf[k]);
		Fm[k]=log(gf[k]);
		gf[K-k]=conj(gf[k]);
		Fp[K-k]=conj(Fp[k]);
		Fm[K-k]=conj(Fm[k]);
		}
}}
fprintf(o,".01 W 0 0 0 RGB\n");
for(k=K/4; k<= 3*K/4; k++ ){y=Y(k);u=Re(gf[k]);if(k==K/4)M(y,u)else L(y,u)}//fprintf(o,"S\n");
for(k=K/4; k<= 3*K/4; k++ ){y=Y(k);u=Im(gf[k]);if(k==K/4)M(y,u)else L(y,u)}fprintf(o,"S\n");

//DO(k,K1){y=Y(k);u=Re(gf[k]);if(k==0)M(y,u)else L(y,u)} fprintf(o,"0 0 0 RGB S\n");
//DO(k,K1){y=Y(k);u=Im(gf[k]);if(k==0)M(y,u)else L(y,u)} fprintf(o,"0 0 0 RGB S\n");


fprintf(o,"showpage\n\%\%\%Trailer"); fclose(o); 
//system( "ggv fig03.eps");
system(  "open fig03.eps");
system("ps2pdf fig03.eps");
getchar(); system("killall Preview");

/*
printf("Generation of reserve fig03c which perhaps will not be used\n");

int M=241,M1=M+1;
int N=100,N1=N+1;
DB X[M1],Y[N1], g[M1*N1],f[M1*N1], w[M1*N1]; // w is working array.
char v[M1*N1]; // v is working array
printf("Output  fig03c.eps\n");
       o=fopen("fig03c.eps","w");ado(o,0,0,124,84);
//fprintf(o,"204 104 translate\n 20 20 scale\n");
  fprintf(o,"82 42 translate\n 20 20 scale\n");

DB sy=2.05/sinh(.04*N/2.);
DO(m,M1) X[m]=-10+.05*m;
DO(n,N1) Y[n]=sy*sinh(.04*(n-N/2));

//for(m=-10;m<9;m++) {M(m,-4)L(m,4)}
for(m=-4;m<3;m++) {M(m,-2)L(m,2)}
for(n=-2;n<3;n++) {M(  -4,n)L(2,n)} fprintf(o,".006 W 0 0 0 RGB S\n");

z_type tm,tp,F[M1*N1];; 

for(m=190;m<212;m++){x=X[m];
DO(n,N1){y=Y[n]; z=z_type(x,y); c=0.;
        DO(k,K1)
	{ t=Y(k); tm=z_type(-1.,t);
		  tp=z_type( 1.,t);
	 d= Fp[k]/(tp-z)
       	  - Fm[k]/(tm-z) ;
         if(k==0 || k==K) d/=2;
         c+=d;
	}
        cu=.5-I/(2.*M_PI)*log( (z_type(1.,-A)+z)/(z_type(1., A)-z) );
        cd=.5-I/(2.*M_PI)*log( (z_type(1.,-A)-z)/(z_type(1., A)+z) );
        c=c*(dy/(2.*M_PI)) + Zo*cu+Zc*cd;
	F[m*N1+n]=c;
	}}

for(m=212;m<M1;m++)  
	DO(n,N1)
		{ 
		F[m*N1+n] = exp( F[(m-20)*N1+n] ); 
		}
for(m=189;m>=0;m--)
	DO(n,N1)
		{ 
		F[m*N1+n] = log( F[(m+20)*N1+n] ); 
		}

DO(m,M1){
DO(n,N1){
	if( X[m]<2.2 && X[m]>-4.1)
		{ c=F[m*N1+n];
		  g[m*N1+n]=Re(c);
		  f[m*N1+n]=Im(c);
		}
	else
	{	  g[m*N1+n]=9.e99;
		  f[m*N1+n]=9.e99;
	}
}}

DB p=.9;
                  conto(o,f,w,v,X,Y,M,N, (-3*M_PI ),-999,999); fprintf(o,".04 W 1 0 1 RGB S\n");
                  conto(o,f,w,v,X,Y,M,N, ( -M_PI  ),-999,999); fprintf(o,".04 W 1 0 1 RGB S\n");
for(n=2;n<10;n+=2)conto(o,f,w,v,X,Y,M,N, (-3.+.1*n),-p, p); fprintf(o,".01 W 0 1 0 RGB S\n");
                  conto(o,f,w,v,X,Y,M,N, (-2.     ),-2 ,2); fprintf(o,".01 W 1 0 0 RGB S\n");
for(n=2;n<10;n+=2)conto(o,f,w,v,X,Y,M,N, (-2.+.1*n),-p ,p); fprintf(o,".01 W 0 1 0 RGB S\n");
                  conto(o,f,w,v,X,Y,M,N, (-1.     ),-2 ,2); fprintf(o,".01 W 1 0 0 RGB S\n");
for(n=2;n<10;n+=2)conto(o,f,w,v,X,Y,M,N, (-1.+.1*n),-p ,p); fprintf(o,".01 W 0 1 0 RGB S\n");
                  conto(o,f,w,v,X,Y,M,N, (0.      ),-999,999); fprintf(o,".01 W 0 0 0 RGB S\n");
for(n=2;n<10;n+=2)conto(o,f,w,v,X,Y,M,N, (    .1*n),-p ,p); fprintf(o,".01 W 0 1 0 RGB S\n");
                  conto(o,f,w,v,X,Y,M,N, ( 1.     ),-9 ,9); fprintf(o,".01 W 0 0 1 RGB S\n");
for(n=2;n<10;n+=2)conto(o,f,w,v,X,Y,M,N, ( 1.+.1*n),-p ,p); fprintf(o,".01 W 0 1 0 RGB S\n");
                  conto(o,f,w,v,X,Y,M,N, ( 2.     ),-9 ,9); fprintf(o,".01 W 0 0 1 RGB S\n");
for(n=2;n<10;n+=2)conto(o,f,w,v,X,Y,M,N, ( 2.+.1*n),-p, p); fprintf(o,".01 W 0 1 0 RGB S\n");
                  conto(o,f,w,v,X,Y,M,N, ( M_PI   ),-999,999); fprintf(o,".04 W 1 0 1 RGB S\n");
                  conto(o,f,w,v,X,Y,M,N, (3*M_PI  ),-999,999); fprintf(o,".04 W 1 0 1 RGB S\n");

                  conto(o,g,w,v,X,Y,M,N, (-2.     ),-p,p); fprintf(o,".01 W 0 0 0 RGB S\n");
for(n=2;n<10;n+=2)conto(o,g,w,v,X,Y,M,N, (-2.+.1*n),-p,p); fprintf(o,".01 W 1 0 0 RGB S\n");
                  conto(o,g,w,v,X,Y,M,N, (-1.     ),-3,3); fprintf(o,".01 W 0 0 0 RGB S\n");
for(n=2;n<10;n+=2)conto(o,g,w,v,X,Y,M,N, (-1.+.1*n),-p,p); fprintf(o,".01 W 1 0 0 RGB S\n");
                  conto(o,g,w,v,X,Y,M,N, (0.      ),-999,999); fprintf(o,".02 W 0 0 0 RGB S\n");
for(n=2;n<10;n+=2)conto(o,g,w,v,X,Y,M,N, (    .1*n),-p,p); fprintf(o,".01 W 0 0 1 RGB S\n");
                  conto(o,g,w,v,X,Y,M,N, ( 1.     ),-3,3); fprintf(o,".01 W 0 0 0 RGB S\n");
for(n=2;n<10;n+=2)conto(o,g,w,v,X,Y,M,N, ( 1.+.1*n),-p,p); fprintf(o,".01 W 0 0 1 RGB S\n");
                  conto(o,g,w,v,X,Y,M,N, ( 2.     ),-p,p); fprintf(o,".01 W 0 0 0 RGB S\n");

M(-4.1,0)L(-1.98,0)fprintf(o,".04 W 1 0 1 RGB S\n");
fprintf(o,"showpage\n\%\%\%Trailer"); fclose(o);
//system( "ggv fig03c.eps");
system(  "open fig03c.eps");
system("ps2pdf fig03c.eps");
getchar();
system("killall Preview");

*/
}
