#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#define DB double
#include <complex.h>
#define z_type complex<double>
#define Re(x) (x).real()
#define Im(x) (x).imag()
#define I z_type(0.,1.)
z_type Zo=z_type(.31813150520476413, 1.3372357014306895);
z_type Zc=z_type(.31813150520476413,-1.3372357014306895);
#define DO(x,y) for(x=0;x<y;x++)
#include "f3c.cin"
#include"ado.cin"
#define DO(x,y) for(x=0;x<y;x++)
#define M(x,y) fprintf(o,"%5.3f %5.3f M\n",1.*(x),1.*(y));
#define L(x,y) fprintf(o,"%5.3f %5.3f L\n",1.*(x),1.*(y));
#define o(x,y) fprintf(o,"%5.3f %5.3f o\n",1.*(x),1.*(y));
//#include "advacon.cin"
#include "GLxw2048.inc"
main(){ int j,k,m,n; DB x,y, u, t; z_type z,c,d, cu,cd; FILE *o;
int K=NPO; DB A=24.; printf("K=%3d A=%3.1f\n",K,A);
int J=K-1;  z_type E[K],F[K],G[K],H[K],U[K],V[K];

o=fopen("fig0.dat","r"); DO(k,K){ fscanf(o,"%d%lf%lf",&n,&x,&y);// printf("%4d %6.4f %6.4f\n",n,x,y);	
				F[k]=z_type(x,y);}  fclose(o);
DO(k,K){c=F[k];E[k]=log(c);G[k]=exp(c);}

       o=fopen("fig05a.eps","w");ado(o,0,0,204,44);
printf("plot in fig05a.eps\n");
fprintf(o,"102 22 translate\n 10 10 scale\n");
for(j=-10;j<11;j+=1){M(j,-2)L(j,2);}
M(-10 , 2)L(10 , 2); 
M(-10 , 1)L(10 , 1); 
M(-10 ,-1)L(10 ,-1); 
M(-10 ,-2)L(10 ,-2);  fprintf(o,".006 W S\n");
M(-10.1,0)L(10.1,0);  fprintf(o,".02 W S\n");
fprintf(o,".01 W S 1 setlinejoin 1 setlinecap\n");

x=-.5;
DO(n,202){ y=.1*(n-100); z=z_type(x,y); c=0.;  //printf(" %3d",n);
	 DO(k,K){t=A*GLx[k]; c+= GLw[k]*( G[k]/(z_type( 1.,t)-z) - E[k]/(z_type(-1.,t)-z) );}	
	 cu=.5-I/(2.*M_PI)*log( (z_type(1.,-A)+z)/(z_type(1., A)-z) );
	 cd=.5-I/(2.*M_PI)*log( (z_type(1.,-A)-z)/(z_type(1., A)+z) );
	 U[n]=c*(A/(2.*M_PI)) +Zo*cu+Zc*cd;
	 }


x= .5;
DO(n,202){ y=.1*(n-100); z=z_type(x,y); c=0.;  //printf(" %3d",n);
	 DO(k,K){t=A*GLx[k]; c+= GLw[k]*( G[k]/(z_type( 1.,t)-z) - E[k]/(z_type(-1.,t)-z) );}	
	 cu=.5-I/(2.*M_PI)*log( (z_type(1.,-A)+z)/(z_type(1., A)-z) );
	 cd=.5-I/(2.*M_PI)*log( (z_type(1.,-A)-z)/(z_type(1., A)+z) );
	 V[n]=c*(A/(2.*M_PI)) +Zo*cu+Zc*cd;
	 }
/*
for(k=0;k<202;k++){y=.1*(k-100);u=1.e14*Re(U[k]-log(V[k])); if(k==0)M(y,u)else L(y,u)}fprintf(o,"0.04 W 1 0 1 RGB S\n");
for(k=0;k<202;k++){y=.1*(k-100);u=1.e14*Im(U[k]-log(V[k])); if(k==0)M(y,u)else L(y,u)}fprintf(o,"0.04 W 1 0 1 RGB S\n");

for(k=0;k<202;k+=2){y=.1*(k-100);u=1.e14*Re(exp(U[k])-(V[k])); if(k==0)M(y,u)else L(y,u)}fprintf(o,"0.12 W 0 1 0 RGB S\n");
for(k=0;k<202;k+=2){y=.1*(k-100);u=1.e14*Im(exp(U[k])-(V[k])); if(k==0)M(y,u)else L(y,u)}fprintf(o,"0.12 W 0 1 0 RGB S\n");
*/

for(k=0;k<202;k+=1){y=.1*(k-100);u=Re(U[k]); if(k==0) M(y,u)else L(y,u)} fprintf(o,"0.08 W 0 .5 1 RGB S\n");
for(k=0;k<202;k+=1){y=.1*(k-100);u=Im(U[k]); if(k==0) M(y,u)else L(y,u)} fprintf(o,"0.08 W 1 .5 0 RGB S\n");

for(k=0;k<202;k+=1){y=.1*(k-100);u=Re(V[k]); if(k==0) M(y,u)else L(y,u)} fprintf(o,"0.03 W 0 0 .5 RGB S\n");
for(k=0;k<202;k+=1){y=.1*(k-100);u=Im(V[k]); if(k==0) M(y,u)else L(y,u)} fprintf(o,"0.03 W .5 0 0 RGB S\n");

fprintf(o,"showpage\n\%\%\%Trailer"); fclose(o); 
//system( "ggv fig05a.eps");
system(  "open fig05a.eps");
system("ps2pdf fig05a.eps");


getchar(); system("killall Preview");
}
