#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#define DB double
#include <complex.h>
#define z_type complex<double>
#define Re(x) (x).real()
#define Im(x) (x).imag()
#define I z_type(0.,1.)
#define DO(x,y) for(x=0;x<y;x++)
#include"f4c.cin"
#include"f3c.cin"
z_type Uxp(z_type z){ DB x=Re(z);	if(x<-1) return log(Uxp(z+1.)); 
					if(x>0) return exp(Uxp(z-1.)); 
					return 1.+z;;			}
#include"fgh.cin"
#include"ado.cin"
main(){ int j,k,m,n;  DB x,y, u,v, w,t; FILE *o;

o=fopen("fig10a.eps","w"); ado(o,0,0,128,30);
fprintf(o,"14 14 translate 100 100 scale\n");
#define M(x,y) {fprintf(o,"%5.3f %5.3f M\n",1.+x,0.+y);}
#define L(x,y) {fprintf(o,"%5.3f %5.3f L\n",1.+x,0.+y);}
#define o(x,y) {fprintf(o,"%5.3f %5.3f o\n",1.+x,0.+y);}
M(-1.08,0)L(.08,0)M(0,-.104)L(0,.11)
fprintf(o,".002 setlinewidth 1 setlinecap S\n");
for(m=-9;m<0;m++){x=0.1*m; M(x,-.1)L(x,.1)}
M(0,.1)L(-1,.1)L(-1,-.1)L(0,-.1) fprintf(o,".001 W S\n");

n=-110;for(m=n;m<11;m++){x=.01*m; y=Re(Uxp(x))-(1.+x);y*=10; if(m==n)M(x,y)else L(x,y)}
fprintf(o,".003 W 1 0 0 RGB S\n");

n=-110;for(m=n;m<11;m++){x=.01*m; y=fgh(x)-(1.+x); y*=10; if(m==n)M(x,y)else L(x,y)}
fprintf(o,".005 W 0 1 0 RGB S\n");

n=-110;for(m=n;m<11;m++){x=.01*m; y=Re(F4(x))-(1.+x); y*=10; if(m==n)M(x,y)else L(x,y)}
fprintf(o,".002 W 0 0 0 RGB S\n");


for(m=-11;m<12;m++){	x=.1*m; u=Re(Uxp(x)); v=fgh(x); w=Re(F3(x)); t=Re(F4(x));
//			printf("%4.1f %15.12f %15.12f %15.12f %15.12f\n",x,u,v,w,t);
		printf("%4.1f & %13.10f & %13.10f & %13.10f & %13.10f \\\\ \n",x,u,v,w,t);
}

fprintf(o,"showpage\n\%\%\%Trailer"); fclose(o); 

//system( "ggv fig10a.eps");
system(  "open fig10a.eps");
system("ps2pdf fig10a.eps");
getchar(); system("killall Preview");
//system("more table02.tex");
}

