#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#define DB double
#include <complex.h>
#define z_type complex<double>
#define Re(x) (x).real()
#define Im(x) (x).imag()
#define I z_type(0.,1.)
z_type Zo=z_type(.31813150520476413, 1.3372357014306895);
z_type Zc=z_type(.31813150520476413,-1.3372357014306895);
#define DO(x,y) for(x=0;x<y;x++)
#include "f3c.cin"
#include"ado.cin"
#define DO(x,y) for(x=0;x<y;x++)
#define M(x,y) fprintf(o,"%5.3f %5.3f M\n",1.*(x),1.*(y));
#define L(x,y) fprintf(o,"%5.3f %5.3f L\n",1.*(x),1.*(y));
#include "GLxw2048.inc"
main(){ int j,k,m,n; DB x,y, u, t; z_type z,c,d, cu,cd; FILE *o;
int K=NPO; DB A=24.; printf("K=%3d A=%3.1f\n",K,A);
int J=K-1;  z_type E[K],F[K],G[K],H[K],U[K],V[K];

o=fopen("fig0.dat","r"); DO(k,K){ fscanf(o,"%d%lf%lf",&n,&x,&y);// printf("%4d %6.4f %6.4f\n",n,x,y);	
				F[k]=z_type(x,y);}  fclose(o);
DO(k,K){c=F[k];E[k]=log(c);G[k]=exp(c);}

       o=fopen("x1.eps","w");ado(o,0,0,220,292);
printf("plot in x1.eps\n");
fprintf(o,"110 30 translate\n 100 100 scale\n");
for(j=-10;j<11;j+=1)if(j!=0)      {M(.1*j,-.1)L(.1*j,2.5);}
for(j= -1;j<26;j+=1)if(j/10*10!=j){M(-1,.1*j)L(1,.1*j);}	fprintf(o,"2 setlinecap .0018 W S\n");
//for(j=-10;j<11;j+=20)           {M(.1*j,-.1)L(.1*j,2.5);}
for(j=  10;j<25;j+=10)            {M(-1,.1*j)L(1,.1*j);}  fprintf(o,".004 W S\n");
for(j=  0;j<2;j+=10)             {M(-1,.1*j)L(1.04,.1*j);}
                                 {M(   0,-.1)L(   0,2.54);} fprintf(o,".005 W S\n");
 
fprintf(o,"1 setlinejoin 1 setlinecap\n");

y=0.;
DO(n,201){ x=0.01*(n-100); z=z_type(x,y); c=0.;  //printf(" %3d",n);
	 DO(k,K){t=A*GLx[k]; c+= GLw[k]*( G[k]/(z_type( 1.,t)-z) - E[k]/(z_type(-1.,t)-z) );}	
	 cu=.5-I/(2.*M_PI)*log( (z_type(1.,-A)+z)/(z_type(1., A)-z) );
	 cd=.5-I/(2.*M_PI)*log( (z_type(1.,-A)-z)/(z_type(1., A)+z) );
	 V[n]=c*(A/(2.*M_PI)) +Zo*cu+Zc*cd;
	// printf("n=%4d, x=%6.2f  %6.3f %6.3f\n",n,x,Re(V[n]),Im(V[n])); 
	 }

for(k=0;k<201;k+=1){x=.01*(k-100);u=Re(V[k]); if(k/2*2==k)M(x,u)else L(x,u)}fprintf(o,"0.008 W 1 0 0 RGB S\n");

x=1-Re(V[100]); 
DO(m,16){
	z=z_type(x,y); c=0.;
	DO(k,K){t=A*GLx[k]; c+= GLw[k]*( G[k]/(z_type( 1.,t)-z) - E[k]/(z_type(-1.,t)-z) );}	
	cu=.5-I/(2.*M_PI)*log( (z_type(1.,-A)+z)/(z_type(1., A)-z) );
	cd=.5-I/(2.*M_PI)*log( (z_type(1.,-A)-z)/(z_type(1., A)+z) );
	c=c*(A/(2.*M_PI)) +Zo*cu+Zc*cd;
	x+=1.-Re(c); printf("%17.16f, %19.16f\n",Re(c),x);
	}


DB x1=x;
// for(k=0;k<201;k+=2){x=.01*(k-100);u=Im(V[k]); if(k==0)M(x,u)else L(x,u)}fprintf(o,"0.004 W 1 0 0 RGB S\n");


DO(n,201){ x=0.01*(n-100); z=z_type(x+x1,y); c=0.;  //printf(" %3d",n);
	 DO(k,K){t=A*GLx[k]; c+= GLw[k]*( G[k]/(z_type( 1.,t)-z) - E[k]/(z_type(-1.,t)-z) );}	
	 cu=.5-I/(2.*M_PI)*log( (z_type(1.,-A)+z)/(z_type(1., A)-z) );
	 cd=.5-I/(2.*M_PI)*log( (z_type(1.,-A)-z)/(z_type(1., A)+z) );
	 V[n]=c*(A/(2.*M_PI)) +Zo*cu+Zc*cd;
	// printf("n=%4d, x=%6.2f  %6.3f %6.3f\n",n,x,Re(V[n]),Im(V[n])); 
	 }


j=66;
//for(k=j;k<132;k++){x=.01*(k-100);u=1.e13*(Re(V[k+50])-exp(Re(V[k-50])));if(k==j)M(x,u)else L(x,u)}
//fprintf(o,"0.008 W 1 0 1 RGB S\n");
for(k=j;k<132;k++){x=.01*(k-100);u=1.e13*(log(Re(V[k+50]))-Re(V[k-50]));if(k==j)M(x,u)else L(x,u)}
fprintf(o,"0.01 W 0 1 0 RGB S\n");

for(k=0;k<201;k+=1){x=.01*(k-100);u=Re(V[k]); if(k==0)M(x,u)else L(x,u)}fprintf(o,"0.003 W 0 0 .5 RGB S\n");

fprintf(o,"showpage\n\%\%\%Trailer"); fclose(o); 
//system( "ggv x1.eps");
system(  "open x1.eps");
system("ps2pdf x1.eps");

o=fopen("x1.inc","w");
fprintf(o,"DB x1=%18.14f;\n",x1);
fclose(o);

getchar(); system("killall Preview");
}
